`timescale 1ns/1ps

module twofish_roundTB();

parameter DATA_WIDTH = 4;
parameter COUNT_TO = 23;
reg clk_i;
reg reset_ni;
reg enable_i;
reg [DATA_WIDTH-1:0] R0_i;
reg [DATA_WIDTH-1:0] R1_i;
reg [DATA_WIDTH-1:0] R2_i;
reg [DATA_WIDTH-1:0] R3_i;

wire toggle_o;
wire [(DATA_WIDTH*4)-1:0] round_o;
wire [4:0] round_number;

twofish_round
#(
    .DATA_WIDTH(DATA_WIDTH),
    .COUNT_TO(COUNT_TO)
) 
DUT(
    .clk_i(clk_i)              ,
    .reset_ni(reset_ni)        ,
    .enable_i(enable_i)        ,
    .R0_i(R0_i)                ,
    .R1_i(R1_i)                ,
    .R2_i(R2_i)                ,
    .R3_i(R3_i)                ,
    .round_o(round_o)          ,
    .toggle_o(toggle_o)
);
counter
#(
    .COUNT_TO(COUNT_TO)
 )
counter_inst
(
    .clk_i (clk_i),
    .reset_ni(reset_ni),
    .count_en_i(toggle_o),
    .count_o(round_number)
);

initial begin
clk_i = 'b0;
enable_i = 'b0;
reset_ni = 'b1;
R0_i = 'd1;
R1_i = 'd2;
R2_i = 'd3;
R3_i = 'd4;

@(posedge clk_i)
reset_ni = 'b0;
@(posedge clk_i)
reset_ni = 'b1;
@(posedge clk_i)
#1 enable_i = 'b1;
@(posedge clk_i)
#1 enable_i = 'b0;
@(posedge clk_i)
R0_i = 'bx;
R1_i = 'bx;
R2_i = 'bx;
R3_i = 'bx;
end

always
    #10 clk_i =~clk_i;

endmodule




